Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nwoods.jgo
Class JGoOverview

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  com.nwoods.jgo.JGoView
                      com.nwoods.jgo.JGoOverview

All Implemented Interfaces:
  java.awt.dnd.Autoscroll, java.awt.datatransfer.ClipboardOwner, java.awt.dnd.DragGestureListener, java.awt.dnd.DragSourceListener, java.awt.dnd.DropTargetListener, java.util.EventListener, java.awt.image.ImageObserver, JGoDocumentListener, JGoObjectCollection, JGoObjectSimpleCollection, java.awt.event.KeyListener, java.awt.MenuContainer, java.awt.print.Printable, java.io.Serializable

public class JGoOverview
extends JGoView

A simple overview window, displaying another JGoView's document at a reduced scale, and allowing navigation by the user.

This view can be used once you call setObserved with another JGoView. This overview displays a rectangle that indicates the position and extent of the Observed's view onto the document. The user can change the position of the Observed view in the document by either dragging the rectangle or clicking.

The user cannot select objects in this view, nor can the user drop something from another window or drag something out of this window. This overview does display tooltips for objects, to make it easier for users to tell where they are.

See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class com.nwoods.jgo.JGoView
`JGoView.JGoViewCanvas`

Nested classes inherited from class javax.swing.JComponent
`javax.swing.JComponent.AccessibleJComponent`

Nested classes inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary

Fields inherited from class com.nwoods.jgo.JGoView
`ChangedDimensions, ChangedOrigin, ChangedPen, ChangedSnapMove, ChangedSnapResize, ChangedSpot, ChangedStyle, DebugEvents, EventMouseDown, EventMouseMove, EventMouseUp, GridCross, GridDot, GridInvisible, GridLine, MouseStateAction, MouseStateCreateLink, MouseStateCreateLinkFrom, MouseStateDragBoxSelection, MouseStateLast, MouseStateMove, MouseStateNone, MouseStateResize, MouseStateSelection, NoSnap, SnapAfter, SnapJump`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.print.Printable
`NO_SUCH_PAGE, PAGE_EXISTS`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JGoOverview()` Construct an overview window displaying objects at one eighth scale.

Method Summary
`int` | `computeAcceptableDrop(java.awt.dnd.DropTargetDragEvent e)` Disallow dragging from other windows to here.
`void` | `doBackgroundClick(int modifiers, java.awt.Point dc, java.awt.Point vc)` Clicking somewhere other than in the overview rectangle will move the view to be centered at that point.
`JGoDocument` | `getDocument()` Make sure this is always looking at the same document as the observed's document.
`java.awt.Dimension` | `getDocumentSize()` Ignore any view objects.
`JGoView` | `getObserved()` Get the JGoView that is being watched/tracked.
`JGoOverviewRectangle` | `getOverviewRect()` Returns the rectangle in this view that the user drags to change the ViewPosition of the observed view.
`java.lang.String` | `getToolTipText(java.awt.event.MouseEvent evt)` Show tooltips, so users might get a clue about which object is which even though the objects are so small.
`boolean` | `isDropFlavorAcceptable(java.awt.dnd.DropTargetDragEvent e)` Leave drag-and-drop enabled for autoscrolling, but don't allow any drops here.
`boolean` | `isIncludingNegativeCoords()` This is true if the Observed view's isIncludeNegativeCoords() is true.
`JGoObject` | `pickDocObject(java.awt.Point pointToCheck, boolean selectableOnly)` Ignore all document objects; only the JGoOverviewRectangle can be selected.
`void` | `removeNotify()` When the Overview window is no longer needed, make sure the observed view doesn't keep any references to this view.
`void` | `selectInBox(java.awt.Rectangle rect)` Don't allow anything to be selected by user's rubber band either.
`void` | `setObserved(JGoView observed)` Set the view that this overview is supposed to observe.

Methods inherited from class com.nwoods.jgo.JGoView
`addDocumentListener, addNotify, addObjectAtHead, addObjectAtTail, addViewListener, applyRenderingHints, autoscroll, bringObjectToFront, canPaste, completeDrop, computeEffectiveSelection, computeEffectiveSelection, convertActionToModifiers, convertDocToView, convertDocToView, convertDocToView, convertViewToDoc, convertViewToDoc, convertViewToDoc, copy, copySelection, copyToClipboard, createDefaultModel, createDefaultSelection, createTemporaryLinkForNewLink, createTemporaryPortForNewLink, cut, deleteSelection, disposeJGoGraphics, doCancelMouse, doCancelMoveSelection, doCancelResize, docToViewCoords, docToViewCoords, docToViewCoords, docToViewCoords, docToViewCoords, documentChanged, doDrop, doEndEdit, doLayout, doMouseClick, doMouseDblClick, doMouseDown, doMouseMove, doMouseUp, doMoveSelection, doUncapturedMouseMove, dragDropEnd, dragEnter, dragEnter, dragExit, dragExit, dragGestureRecognized, dragOver, dragOver, drawGridCrosses, drawGridLines, drawXORBox, drawXORRect, drop, dropActionChanged, dropActionChanged, findNearestGridPoint, findObject, fireUpdate, fireUpdate, getAutoscrollInsets, getBackgroundImage, getCanvas, getCorner, getCurrentMouseEvent, getCurrentObject, getDebugFlags, getDefaultCursor, getDefaultPortGravity, getDefaultPrimarySelectionColor, getDefaultSecondarySelectionColor, getDocumentListeners, getDocumentTopLeft, getEditControl, getEditPresentationName, getExtentSize, getFirstLayer, getFirstObjectPos, getFrame, getGridHeight, getGridOrigin, getGridPen, getGridSpot, getGridStyle, getGridWidth, getHorizontalScrollBar, getInternalMouseActions, getJGoGraphics, getLastLayer, getLastObjectPos, getMinimumSize, getNextLayer, getNextObjectPos, getNextObjectPosAtTop, getNumObjects, getObjectAtPos, getPortGravity, getPreferredSize, getPrevLayer, getPrevObjectPos, getPrimarySelectionColor, getPrintDocumentSize, getPrintDocumentTopLeft, getPrintPageRect, getPrintScale, getScale, getSecondarySelectionColor, getSelection, getSnapMove, getSnapResize, getState, getVerticalScrollBar, getViewListeners, getViewPosition, getViewRect, handleActionObject, handleResizing, initializeDragDropHandling, initializeMouseHandling, insertObjectAfter, insertObjectBefore, internalPrint, isDragDropEnabled, isDragEnabled, isDragsRealtime, isDragsSelectionImage, isDrawsXorMode, isDropEnabled, isEditingTextControl, isEmpty, isFocusTraversable, isHidingDisabledScrollbars, isIgnoreNextMouseDown, isInternalDragDrop, isKeyEnabled, isMouseEnabled, isPrinting, keyClearSelection, keyExtendSelection, keyMultipleSelect, keyPressed, keyReleased, keySingleSelection, keyToggleSelection, keyTyped, limitScale, lostOwnership, moveSelection, newLink, noNewLink, noReLink, onDragDropEnd, onDragEnter, onDragEnter, onDragExit, onDragExit, onDragGestureRecognized, onDragOver, onDragOver, onDrop, onDropActionChanged, onDropActionChanged, onGridChange, onKeyEvent, onMouseDragged, onMouseMoved, onMousePressed, onMouseReleased, onPaintComponent, onScrollEvent, paintBackgroundDecoration, paintDocumentObjects, paintPaperColor, paintView, paintViewObjects, paste, pasteFromClipboard, pickActionObject, pickHandle, pickNearestPort, pickObject, pickPort, print, print, printBegin, printDecoration, printEnd, printPreview, printPreview, printShowPageDialog, printView, reLink, removeDocumentListener, removeObject, removeObjectAtPos, removeViewListener, scrollRectToVisible, selectAll, selectObject, sendObjectToBack, setAutoscrollInsets, setBackgroundImage, setBounds, setBounds, setCorner, setCurrentObject, setCursor, setCursorImmediately, setDebugFlags, setDefaultCursor, setDefaultPortGravity, setDefaultPrimarySelectionColor, setDefaultSecondarySelectionColor, setDocument, setDragDropEnabled, setDragEnabled, setDragsRealtime, setDragsSelectionImage, setDrawsXorMode, setDropEnabled, setEditControl, setGridHeight, setGridOrigin, setGridPen, setGridSpot, setGridStyle, setGridWidth, setHidingDisabledScrollbars, setHorizontalScrollBar, setIgnoreNextMouseDown, setIncludingNegativeCoords, setInternalMouseActions, setKeyEnabled, setMouseEnabled, setPrimarySelectionColor, setScale, setSecondarySelectionColor, setSize, setSize, setSnapMove, setSnapResize, setState, setVerticalScrollBar, setViewPosition, setViewPosition, snapAllObjects, snapAllObjects, snapObject, snapObject, startActionObject, startDragBoxSelection, startMoveSelection, startNewLink, startReLink, startResizing, updateScrollbars, updateView, updateView, validDestinationPort, validLink, validSourcePort, viewToDocCoords, viewToDocCoords, viewToDocCoords, viewToDocCoords, viewToDocCoords`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getNextFocusableComponent, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setComponentOrientation, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JGoOverview

    public JGoOverview()

  Construct an overview window displaying objects at one eighth scale.

Method Detail

### removeNotify

    public void removeNotify()

  When the Overview window is no longer needed, make sure the observed view doesn't keep any references to this view.

### setObserved

    public void setObserved(JGoView observed)

  Set the view that this overview is supposed to observe.

  Parameters:
    `observed` - a JGoView that must not be a JGoOverview, but may be null to turn this overview "off"/blank

### getObserved

    public JGoView getObserved()

  Get the JGoView that is being watched/tracked.

### isDropFlavorAcceptable

    public boolean isDropFlavorAcceptable(java.awt.dnd.DropTargetDragEvent e)

  Leave drag-and-drop enabled for autoscrolling, but don't allow any drops here.

  Overrides:
    `isDropFlavorAcceptable` in class `JGoView`

### computeAcceptableDrop

    public int computeAcceptableDrop(java.awt.dnd.DropTargetDragEvent e)

  Disallow dragging from other windows to here.

  Overrides:
    `computeAcceptableDrop` in class `JGoView`

### getOverviewRect

    public JGoOverviewRectangle getOverviewRect()

  Returns the rectangle in this view that the user drags to change the ViewPosition of the observed view.

### pickDocObject

    public JGoObject pickDocObject(java.awt.Point pointToCheck,
                                   boolean selectableOnly)

  Ignore all document objects; only the JGoOverviewRectangle can be selected.

  Overrides:
    `pickDocObject` in class `JGoView`
  Parameters:
    `pointToCheck` - the point under which to find the object, in document coordinates
    `selectableOnly` - if true, consider only selectable objects

### selectInBox

    public void selectInBox(java.awt.Rectangle rect)

  Don't allow anything to be selected by user's rubber band either.

  Overrides:
    `selectInBox` in class `JGoView`
  Parameters:
    `rect` - the Rectangle, in document coordinates

### doBackgroundClick

    public void doBackgroundClick(int modifiers,
                                  java.awt.Point dc,
                                  java.awt.Point vc)

  Clicking somewhere other than in the overview rectangle will move the view to be centered at that point.

  Overrides:
    `doBackgroundClick` in class `JGoView`

### getDocument

    public JGoDocument getDocument()

  Make sure this is always looking at the same document as the observed's document.

  Overrides:
    `getDocument` in class `JGoView`
  Returns:
    the document for this view.

### getDocumentSize

    public java.awt.Dimension getDocumentSize()

  Ignore any view objects.

  Overrides:
    `getDocumentSize` in class `JGoView`
  Returns:
    the size of the document in document coordinates.

### isIncludingNegativeCoords

    public boolean isIncludingNegativeCoords()

  This is true if the Observed view's isIncludeNegativeCoords() is true.

  Overrides:
    `isIncludingNegativeCoords` in class `JGoView`

### getToolTipText

    public java.lang.String getToolTipText(java.awt.event.MouseEvent evt)

  Show tooltips, so users might get a clue about which object is which even though the objects are so small.

  Note that it might not be possible for the user to position the mouse pointer over every objects, because thin objects may take less than one pixel.

  Overrides:
    `getToolTipText` in class `JGoView`
  Parameters:
    `evt` - the mouse event generated when passing over the canvas.
  Returns:
    a string for a tooltip, or null if this object should have no tooltip and the view should ask this object's parent

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD